freeslot("MT_EXEBULLET", "S_EXEBULLET1", "SPR_ESHT", "sfx_rexfir")
for i = 1, 4
end
for a = 1, 10
freeslot("S_EXEBULLET"..a)
end

mobjinfo[MT_EXEBULLET] = {
        spawnstate = S_EXEBULLET1,
		spawnhealth = 1,
        deathstate = S_XPLD1,
		reactiontime = 32,
		painchance = 200,
		speed = 50*FRACUNIT,
        radius = 4*FRACUNIT,
        height = 8*FRACUNIT,
        flags = MF_NOGRAVITY|MF_MISSILE
}

freeslot("S_REXER_FIRE", "SPR2_REXF", "sfx_rexjum")

states[S_REXER_FIRE] = {
        sprite = SPR_PLAY,
        frame = SPR2_REXF,
        tics = 15,
        nextstate = S_PLAY_WALK
}

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "rexer"
			if not (player.mo.spindown)
				player.mo.spindown = 0
			end
			if (player.cmd.buttons & BT_SPIN)
			and not player.exiting
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_JUMPED)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.spindown == 0
			and not (CBW_Battle)
				player.mo.spindown = 1
				player.mo.state = S_REXER_FIRE
				S_StartSound(player.mo, sfx_rexfir)
				P_SpawnPlayerMissile(player.mo, MT_EXEBULLET)
				A_Thrust(player.mo, 0, 1)
			end
			if (player.cmd.buttons & BT_SPIN)
			and not player.exiting
			and (player.mo.state == S_PLAY_JUMP)
			and (player.pflags & PF_JUMPED)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.spindown == 0
			and not player.weapondelay
			and (CBW_Battle)
				player.mo.spindown = 1
				player.charability2 = CA2_SPINDASH
				player.weapondelay = 5*TICRATE
				player.mo.state = S_PLAY_SPRING
				S_StartSound(player.mo, sfx_rexjum)
				P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z, player.mo.scale*64,12, MT_DUST,ANGLE_90,nil,true)
				P_SetObjectMomZ(player.mo, 12*FRACUNIT)
			end
			if (player.cmd.buttons & BT_SPIN)
			and player.mo.spindown == 0
			and (CBW_Battle)
				player.mo.spindown = 1
				player.charability2 = CA2_SPINDASH
			end
			if (player.cmd.buttons & BT_SPIN)
			and (player.mo.state == S_PLAY_JUMP)
			and not player.exiting
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_SPINNING)
			and not (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_PAIN)
			and not (player.pflags & PF_STASIS)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.spindown == 0
			and not player.weapondelay
			and not (CBW_Battle)
				player.mo.spindown = 1
				player.mo.state = S_PLAY_SPRING
				player.weapondelay = 5*TICRATE
				S_StartSound(player.mo, sfx_fire)
				P_SetObjectMomZ(player.mo, 12*FRACUNIT)
				P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z, player.mo.scale*64,12, MT_DUST,ANGLE_90,nil,true)
				local an = player.mo.angle
				local slope = player.aiming
				local exebomb = P_SpawnMobj(player.mo.x + (1*cos(an)), player.mo.y + (1*sin(an)), player.mo.z+6*FRACUNIT, MT_FBOMB)
				exebomb.scale = player.mo.scale
				exebomb.target = player.mo
				P_SetObjectMomZ(exebomb, -12*FRACUNIT)
				local speed = 70*FRACUNIT
				if player.mo.eflags & MFE_VERTICALFLIP then
					exebomb.flags2 = $1|MF2_OBJECTFLIP
					exebomb.z = $1 - exebomb.height - player.mo.height/3
				end
				exebomb.angle = an
				exebomb.momx = FixedMul(speed, cos(an))
				exebomb.momy = FixedMul(speed, sin(an))
				exebomb.momx = FixedMul(exebomb.momx, cos(slope))
				exebomb.momy = FixedMul(exebomb.momy, cos(slope))
				exebomb.momz = FixedMul(speed, sin(slope))
			end
			if not (player.cmd.buttons & BT_SPIN)
				player.mo.spindown = 0
			end
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "rexer"
			if not (player.mo.custom1down)
				player.mo.custom1down = 0
			end
			if (player.cmd.buttons & BT_CUSTOM1)
			and not player.weapondelay
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not player.powers[pw_super]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not (player.pflags & PF_SPINNING)
			and player.mo.custom1down == 0
				player.mo.custom1down = 1
				player.weapondelay = 2*TICRATE
				S_StartSound(player.mo, sfx_cdfm33)
				player.powers[pw_flashing] = 20
				local airdodge = P_SpawnGhostMobj(player.mo)
				airdodge.color = SKINCOLOR_RED
				airdodge.colorized = true
				airdodge.blendmode = AST_ADD
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
				player.mo.custom1down = 0
			end
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "rexer")
			if not player.powers[pw_extralife]
			and not (player.exiting)
			if player.powers[pw_super] then
				S_ChangeMusic("hopes",true,player)
			end	
		else
			P_RestoreMusic(player)
			end
		end
	end
end)

local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true

	local REX_BATTLE = function(mo,doaction,pressedaction)
		local player = mo.player
		player.actiontext = "ShotGun Gravity"
		player.actionrings = 15
		if player.actionstate == 0 and doaction == 1 then
			player.actionstate = 1
			player.actiontime = 0
			CBW_Battle.PayRings(player)
		end	
		
		if player.actionstate == 1
			CBW_Battle.ApplyCooldown(player,TICRATE)
			player.actiontime = 0
			player.drawangle = player.mo.angle
			player.actionstate = 0
			local exebullet = P_SpawnGhostMobj(player.mo)
			exebullet.color = SKINCOLOR_RED
			exebullet.colorized = true
			exebullet.blendmode = AST_ADD
			S_StartSound(player.mo, sfx_rexfir)
			P_SpawnPlayerMissile(mo, MT_EXEBULLET, MF2_SCATTER)
			local scat1 = P_SPMAngle(mo, MT_EXEBULLET, mo.angle-ANG2, 1, MF2_SCATTER)
			local scat2 = P_SPMAngle(mo, MT_EXEBULLET, mo.angle+ANG2, 1, MF2_SCATTER)
			local scat3 = P_SPMAngle(mo, MT_EXEBULLET, mo.angle, 1, MF2_SCATTER)
			scat3.momz = $1 + FixedMul(2*FRACUNIT, mo.scale)
			local scat4 = P_SPMAngle(mo, MT_EXEBULLET, mo.angle, 1, MF2_SCATTER)
			scat4.momz = $1 - FixedMul(2*FRACUNIT, mo.scale)
		end
	end

	CBW_Battle.SkinVars["rexer"] = {
		weight = 100,
		shields = 1,
		guard_frame = 2,
		special = REX_BATTLE,
 		guard_enabled = true,
 		guard_frame = 2,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry
	}
end)